﻿using System;
using System.Text;
using System.Numerics;

namespace ModifiedRNGCryptoServiceProvider
{
    /// <summary>
    /// Modified BigInteger
    /// </summary>
    /// <history>© exc-jdbi 2017</history>
    [System.Diagnostics.DebuggerStepThrough()]
    public struct Bignum : IConvertible
    {
        public BigInteger value;
        [System.Diagnostics.DebuggerHidden()]
        public TypeCode GetTypeCode()
        {
            throw new NotImplementedException("It's not possible");
        }
        [System.Diagnostics.DebuggerHidden()]
        public bool ToBoolean(IFormatProvider provider)
        {
            throw new NotImplementedException("It's not possible");
        }
        [System.Diagnostics.DebuggerHidden()]
        public byte ToByte(IFormatProvider provider)
        {
            return (byte)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public char ToChar(IFormatProvider provider)
        {
            throw new NotImplementedException("It's not possible");
        }
        [System.Diagnostics.DebuggerHidden()]
        public DateTime ToDateTime(IFormatProvider provider)
        {
            throw new NotImplementedException("It's not possible");
        }
        [System.Diagnostics.DebuggerHidden()]
        public decimal ToDecimal(IFormatProvider provider)
        {
            return (decimal)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public double ToDouble(IFormatProvider provider)
        {
            return Convert.ToDouble(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public short ToInt16(IFormatProvider provider)
        {
            return (Int16)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public Int32 ToInt32(IFormatProvider provider)
        {
            return (Int32)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public long ToInt64(IFormatProvider provider)
        {
            return (Int64)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public sbyte ToSByte(IFormatProvider provider)
        {
            return (sbyte)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public float ToSingle(IFormatProvider provider)
        {
            return (Single)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public string ToString(IFormatProvider provider)
        {
            throw new NotImplementedException("It's not possible");
        }
        [System.Diagnostics.DebuggerHidden()]
        public object ToType(Type conversionType, IFormatProvider provider)
        {
            return this;
        }
        [System.Diagnostics.DebuggerHidden()]
        public ushort ToUInt16(IFormatProvider provider)
        {
            return Convert.ToUInt16(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public UInt32 ToUInt32(IFormatProvider provider)
        {
            return (UInt32)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public UInt64 ToUInt64(IFormatProvider provider)
        {
            return (UInt64)(this.value);
        }
        [System.Diagnostics.DebuggerHidden()]
        public Bignum(BigInteger val)
        {
            this.value = val;
        }
        [System.Diagnostics.DebuggerHidden()]
        public Bignum(Bignum val)
        {
            this.value = val.value;
        }
        [System.Diagnostics.DebuggerHidden()]
        public Bignum(object valu)
        {
            if (valu.GetType() == typeof(BigInteger))
                this.value = (BigInteger)valu;
            else this.value = new BigInteger((double)(valu));
        }
    }
}

