﻿/*  www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 *  github.com/exc-jdbi
 *  Is Free and Opensource
*/
using System;
using System.Diagnostics;
namespace ModifiedRNGCryptoServiceProvider
{
    class Program
    {
        static void Main(string[] args)
        {
            Int32 cnt = 250;
            Program p = new Program();
            Stopwatch sw = new Stopwatch();
            CryptoRnd rnd = new CryptoRnd();

            byte[] bArr = new byte[cnt];
            Int32[] iArr = new Int32[cnt];
            double[] dArr = new double[cnt];
            UInt64[] uiArr = new UInt64[cnt];
            p.PrintTitel();

            //Cryptosichere Random-Arrays mit min/max (Ganzzahlen-Datentypen)
            //***************************************************************

            //Datentype Integer
            Int32 min = Int32.MinValue, max = Int32.MaxValue;
            sw.Restart();
            if (rnd.Interval<Int32>(min, max))
                rnd.GetRnds<Int32>(ref iArr);
            sw.Stop();
            Int64 sw1 = sw.ElapsedMilliseconds;
            p.PrintOut(iArr, sw);

            //Datentype UInt64
            UInt64 max2 = UInt64.MaxValue;
            UInt64 min2 = Convert.ToUInt64(Math.Pow(10, 18));
            sw.Restart();
            if (rnd.Interval<UInt64>(min2, max2))
                rnd.GetRnds<UInt64>(ref uiArr);
            sw.Stop();
            Int64 sw2 = sw.ElapsedMilliseconds;
            p.PrintOut(uiArr, sw);

            //Datentype Byte
            byte min3 = byte.MinValue;
            byte max3 = byte.MaxValue;
            sw.Restart();
            rnd.GetRnds<byte>(ref bArr, min3, max3);
            sw.Stop();
            Int64 sw3 = sw.ElapsedMilliseconds;
            p.PrintOut(bArr, sw);

            //Cryptosichere Random-Arrays (Double-Datentypen)
            //***********************************************
            //Datentype Double ohne Interval ==> GetRndsDbl()
            //Alle Werte [>=0,<=1]
            sw.Restart();
            rnd.GetRndsDbl(ref dArr);
            sw.Stop();
            Int64 sw4 = sw.ElapsedMilliseconds;
            p.PrintOut(dArr, sw);


            //Cryptosichere RndStrings
            //************************
            sw.Restart();
            string sRndAlpha = rnd.GetRndAlpha(cnt);
            sw.Stop();
            Int64 sw5 = sw.ElapsedMilliseconds;

            sw.Restart();
            string sRndAscii = rnd.GetRndAscii(cnt);
            sw.Stop();
            Int64 sw6 = sw.ElapsedMilliseconds;


            //Cryptosichere Random-Array Primes (Natürliche Zahlen)
            //*****************************************************
            UInt64[] uiArrPrimes = new UInt64[cnt];
            byte[] uiArrPrimes2 = new byte[cnt];
            UInt64 min4 = Convert.ToUInt64(Math.Pow(10, 18));
            UInt64 max4 = UInt64.MaxValue;

            sw.Restart();
            if (rnd.Interval<UInt64>(min4, max4))
                rnd.GetRndPrimes<UInt64>(ref uiArrPrimes);
            sw.Stop();
            Int64 sw7 = sw.ElapsedMilliseconds;
            p.PrintOut(uiArrPrimes, sw);

            sw.Restart();
            rnd.GetRndPrimes<byte>(ref uiArrPrimes2, 0, 255);
            sw.Stop();
            Int64 sw8 = sw.ElapsedMilliseconds;
            p.PrintOut(uiArrPrimes2, sw);


            //Einzelne cryptosichere Randoms mit min/max (Ganzzahlige Datentypen)
            //*******************************************************************
            Int32 iRnd = rnd.Next<Int32>(-100, 100);
            UInt64 ulRnd = rnd.Next<UInt64>(1000, 123456789);
            byte blRnd = rnd.Next<byte>(100, 200);

            //Für einzelne cryptosichere Double-Randoms ==> NextDbl() ohne Interval
            //Werte [>=0,<=1]
            double dRnd = rnd.NextDbl();

            //Prime: Wichtig min/max >=0
            Int32 iRng = rnd.NextPrime(15, 899);


            //KonsolenAusgabe Zeiten
            p.PrintFinish();
            Console.WriteLine("\r\nSecure Randoms:");
            p.PrintOut(iArr, sw1);
            p.PrintOut(uiArr, sw2);
            p.PrintOut(bArr, sw3);
            p.PrintOut(dArr, sw4);
            Console.WriteLine("\r\nSecure Randoms String:");
            p.PrintOut(sRndAlpha.ToCharArray(), sw5);
            p.PrintOut(sRndAscii.ToCharArray(), sw6);
            Console.WriteLine("\r\nSecure Randoms Prime:");
            p.PrintOut(uiArrPrimes, sw7);
            p.PrintOut(uiArrPrimes2, sw8);

            Console.ReadKey();
        }
        //KonsolenAusgabe
        //***************
        private void PrintFinish()
        {
            Console.WriteLine("Finish\t************************************************************\r\n");
        }
        private void PrintTitel()
        {
            Console.WriteLine("Cryptographically strong Randomgenerator\r\n****************************************\r\n");
        }
        private void PrintOut<T>(T[] arr, Int64 sww)
        {
            Type typ = arr[0].GetType();
            Console.WriteLine("{2}\t{0}pcs.:\t{1}ms.", arr.Length, sww, typ.ToString());
        }
        private void PrintOut<T>(T[] arr, Stopwatch sww)
        {
            for (Int32 i = 0; i <= arr.Length - 1; i++)
            {
                Console.WriteLine(arr[i]);
            }
            Type typ = arr[0].GetType();
            Console.WriteLine("\r\n{2}\t{0}pcs.:\t{1}ms.\r\n\r\n", arr.Length, sww.ElapsedMilliseconds, typ.ToString());
        }
    }
}
